%Script for Moore-Greitzer surgemodell regulert med CCV
%Brukes til  kjre modellen
%Parametre
H=0.18;
W=0.25;
p0=0.3;
lc=13.33;
c2=1.1;%Regulator trrgassforsterkning
B=1.96;%B-parameter
rw=0.0526;%Angir vskeandel i strmning

dS=1/lc;
dp=(1/(4*B^2*lc));
r_w=1+rw;%Er 1 nr rw=0

t_Reg=1900;%Tid for aktivering av Regulering
Step_Start=0;%Angir stepverdi for t_Reg
Step_Slutt=1;%Angir stepverdi for t_Reg
Step_Start2=1;%Angir stepverdi for t_Reg (2)
Step_Slutt2=0;%Angir stepverdi for t_Reg (2)

S_0=0.25;%Referansepunkt for strmning
%Trykkkningskoeffisient
C_1=((rw*(1.999+5.040*(10^2)*rw+2.505*(10^3)*rw^2+4.504*(10^2)*rw^3+1.001*(10^6)*rw^4))/((1+rw)*(1+1000*rw)^2))*10^3;
%Trykk ut fra kompressorkarakteristikk
P_0=p0+C_1*S_0^2+H*(1+(3/2)*(r_w*(S_0/W)-1)-(1/2)*(r_w*(S_0/W)-1)^3)

syms ga
gam=max(double(solve(0.3+0.18*(1+3/2*((S_0/0.25)-1)-(1/2)*((S_0/0.25)-1)^3)-((c2*S_0)/2)-(1/ga^2)*S_0^2==0,ga)));
gamma_T=round(gam*1000)/1000%Pdragsventilforsterkning
p_0=(1/gamma_T^2)*(S_0)^2%Likevektstrykk over kompresjonssystem
p_c0=p0+C_1*S_0^2-p_0-(((S_0*r_w)^2*H)/(2*W^2))*(((S_0*r_w)/W)-3)%Avviks nullpunktsstrykk  

t_stop=5000;%Simuleringstid
T_s=t_stop/50000;
options=simset('solver', 'ode5','fixedstep',T_s);
sim('MG_CCV',t_stop,options)