%Script for Moore-Greitzer med resirkuleringsventil
%Brukes til  kjre modellen
%Parametre
H=0.18;
W=0.25;
p0=0.3;
lc=13.33;
B=1.96;%B-parameter
rw=0.0526;%Angir vskeandel i strmning

dS=H/lc;
dp=((W/H)/(4*B^2))*(H/lc);

syms x
Karr=p0+H*(1+3/2*((x/W)-1)-(1/2)*((x/W)-1)^3);
dKarr=double(solve(diff(Karr)==0));%Toppunkt til trrgass kompressorkarakteristikk
Surge_M=1.15;% Angir surgemargin prosentsats
Ref=max(dKarr)*Surge_M;%Referansepunkt for resirkuleringsventil
t_Reg=2800;%Tid for aktivering av Regulering

r_w=1+rw;%Er 1 nr rw=0
t_rw=0;%Tid for aktivering av vtgass

S_0=0.4;%Referansepunkt for strmning
%Trykkkningskoeffisient
C_1=((rw*(1.999+5.040*(10^2)*rw+2.505*(10^3)*rw^2+4.504*(10^2)*rw^3+1.001*(10^6)*rw^4))/((1+rw)*(1+1000*rw)^2))*10^3;

%Likevektstrykk
if t_rw==0 && rw>0
    p_0=p0+C_1*S_0^2+H*(1+(3/2)*(r_w*(S_0/W)-1)-(1/2)*(r_w*(S_0/W)-1)^3);
else
    p_0=p0+H*(1+3/2*(((S_0)/W)-1)-(1/2)*(((S_0)/W)-1)^3);
end

syms la
gam=max(double(solve(p0+H*(1+3/2*(((S_0)/W)-1)-(1/2)*(((S_0)/W)-1)^3)==(1/la^2)*(S_0)^2,la)));
gamma_T=round(gam*1000)/1000%Pdragsventilforsterkning

t_stop=5000;%Simuleringstid
T_s=t_stop/30000;
options=simset('solver', 'ode5','fixedstep',T_s);
sim('MG_Resirkulering',t_stop,options)